<?php
/* Generic download log script version 1.3                               */
/* By Jasper Vries (http://www.jaspervries.nl)                           */
/* Available under the terms of the GNU General Public License version 2 */

//if file
if (file_exists($_GET['file'])) {
	
	$filename = 'log.csv';
	
	//create log file
	if (!file_exists($filename)) {
		$handle = fopen($filename, 'w');
		fclose($handle);	
	}
	
	//read download log
	$handle = @fopen($filename, 'r');
	$log = @fread($handle, filesize($filename));
	@fclose($handle);
	
	//don't attempt to write log if contents are not read
	if ($log != FALSE) {
		//most rediculous function ever
		function addone($to) {
			return $to[1].++$to[2].";".date("Y/m/d H:i:s");
		}
		
		//check if file in log
		if (strpos($log, "\"".$_GET['file']."\"") === FALSE) {
			//if not exists, add new entry
			$log .= "\"".$_GET['file']."\";1\r\n";
		}
		else {
			//if exists in new format
			$pattern = "#(\"".$_GET['file']."\";)(\d+);\d{4}/\d{2}/\d{2} \d{2}:\d{2}:\d{2}#";
			if (preg_match($pattern, $log) == 1) {
				$log =  preg_replace_callback($pattern, "addone", $log);
			}
			else {
				//else update old format
				$pattern = "#(\"".$_GET['file']."\";)(\d+)#";
				$log =  preg_replace_callback($pattern, "addone", $log);
			}
		}
		
		//write download log
		$handle = fopen($filename, 'w');
		fwrite($handle, $log);
		fclose($handle);
	}
	
	//get file
	$file = $_GET['file'];
	//Gather relevant info about file
	$len = filesize($file);
	$filename = basename($file);
	$file_extension = strtolower(substr(strrchr($filename,"."),1));
	
	//This will set the Content-Type to the appropriate setting for the file
	$mime_types = array(
		//general
		'txt' => 'text/plain',
		'htm' => 'text/html',
		'html' => 'text/html',
		'php' => 'application/x-httpd-php',
		'css' => 'text/css',
		'js' => 'application/javascript',
		'json' => 'application/json',
		'xml' => 'application/xml',
		'swf' => 'application/x-shockwave-flash',
		'flv' => 'video/x-flv',
		// images
		'png' => 'image/png',
		'jpe' => 'image/jpeg',
		'jpeg' => 'image/jpeg',
		'jpg' => 'image/jpeg',
		'gif' => 'image/gif',
		'bmp' => 'image/bmp',
		'ico' => 'image/vnd.microsoft.icon',
		'tiff' => 'image/tiff',
		'tif' => 'image/tiff',
		'svg' => 'image/svg+xml',
		'svgz' => 'image/svg+xml',
		// archives
		'zip' => 'application/zip',
		'rar' => 'application/x-rar-compressed',
		'exe' => 'application/octet-stream',
		'msi' => 'application/x-msdownload',
		'cab' => 'application/vnd.ms-cab-compressed',
		'tar' => 'application/x-tar',
		// audio/video
		'mp3' => 'audio/mpeg',
		'wav' => 'audio/x-wav',
		'mpg' => 'video/mpeg',
		'mpeg' => 'video/mpeg',
		'qt'  => 'video/quicktime',
		'mov' => 'video/quicktime',
		'avi' => 'video/x-msvideo',
		// adobe
		'pdf' => 'application/pdf',
		'psd' => 'image/vnd.adobe.photoshop',
		'ai' => 'application/postscript',
		'eps' => 'application/postscript',
		'ps' => 'application/postscript',
		// ms office
		'doc' => 'application/msword',
		'rtf' => 'application/rtf',
		'xls' => 'application/vnd.ms-excel',
		'ppt' => 'application/vnd.ms-powerpoint',
		// open office
		'odt' => 'application/vnd.oasis.opendocument.text',
		'ods' => 'application/vnd.oasis.opendocument.spreadsheet',
		
		//default
		'default' => 'application/force-download'
	);
	
	//get mime type by file
	if (array_key_exists($file_extension, $mime_types)) {
		$ctype = $mime_types[$file_extension];
	}
	else {
		$ctype = $mime_types['default'];
	}
	
	//Begin writing headers
	header("Pragma: public");
	header("Expires: 0");
	header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
	header("Cache-Control: public"); 
	header("Content-Description: File Transfer");
	   
	//Use the switch-generated Content-Type
	header("Content-Type: ".$ctype);
	
	//Force the download
	header("Content-Disposition: attachment; filename=".$filename.";");
	header("Content-Transfer-Encoding: binary");
	header("Content-Length: ".$len);
	@readfile($file);
	exit;
	
}
//if no file
else {
	header("location: ./");
}